using System;
using System.ComponentModel;
using System.Collections;

namespace Sturm.CollectionWrapping {
	/// <summary>
	/// This wrapper implements IList - for all IList implementations.
	/// </summary>
	public class TypedListWrapperIList : TypedListWrapper, IList {
		public TypedListWrapperIList( ) {

		}

		public TypedListWrapperIList(IList wrappedIList) {
			this.wrappedIList = wrappedIList;
		}

		public TypedListWrapperIList(IList wrappedIList, PropertyDescriptorCollection propertyDescriptorCollection)
			: base(propertyDescriptorCollection) {
			this.wrappedIList = wrappedIList;
		}

		public TypedListWrapperIList(PropertyDescriptorCollection propertyDescriptorCollection)
			: base(propertyDescriptorCollection) {
		}

		IList wrappedIList;
		public IList WrappedIList {
			get {
				return wrappedIList;
			}
			set {
				wrappedIList = value;
			}
		}

		#region IList Members

		int IList.Add(object value) {
			return wrappedIList.Add(value);
		}

		void IList.Clear( ) {
			wrappedIList.Clear( );
		}

		bool IList.Contains(object value) {
			return wrappedIList.Contains(value);
		}

		int IList.IndexOf(object value) {
			return wrappedIList.IndexOf(value);
		}

		void IList.Insert(int index, object value) {
			wrappedIList.Insert(index, value);
		}

		bool IList.IsFixedSize {
			get { return wrappedIList.IsFixedSize; }
		}

		bool IList.IsReadOnly {
			get { return wrappedIList.IsReadOnly; }
		}

		void IList.Remove(object value) {
			wrappedIList.Remove(value);
		}

		void IList.RemoveAt(int index) {
			wrappedIList.RemoveAt(index);
		}

		object IList.this[int index] {
			get {
				return wrappedIList[index];
			}
			set {
				wrappedIList[index] = value;
			}
		}

		#endregion

		#region ICollection Members

		void ICollection.CopyTo(Array array, int index) {
			wrappedIList.CopyTo(array, index);
		}

		int ICollection.Count {
			get { return wrappedIList.Count; }
		}

		bool ICollection.IsSynchronized {
			get { return wrappedIList.IsSynchronized; }
		}

		object ICollection.SyncRoot {
			get { return wrappedIList.SyncRoot; }
		}

		#endregion

		#region IEnumerable Members

		IEnumerator IEnumerable.GetEnumerator( ) {
			return wrappedIList.GetEnumerator( );
		}

		#endregion
	}
}