using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Collections;

namespace Sturm.CollectionWrapping {
    /// <summary>
	/// This wrapper implements IList&lt;T&gt;, for all such implementations.
	/// </summary>
	/// <typeparam name="T"></typeparam>
	public class TypedListWrapperIListT<T> : TypedListWrapperIList, IList<T> {
		public TypedListWrapperIListT( ) {

		}
		
		public TypedListWrapperIListT(IList<T> wrappedIListT) 
			: base(wrappedIListT as IList) {
			this.wrappedIListT = wrappedIListT;
		}

		public TypedListWrapperIListT(IList<T> wrappedIListT, PropertyDescriptorCollection propertyDescriptorCollection)
			: base(wrappedIListT as IList, propertyDescriptorCollection) {
			this.wrappedIListT = wrappedIListT;
		}

		public TypedListWrapperIListT(PropertyDescriptorCollection propertyDescriptorCollection)
			: base(propertyDescriptorCollection) {
		}

		private IList<T> wrappedIListT;
		public IList<T> WrappedIListT {
			get {
				return wrappedIListT;
			}
			set {
				wrappedIListT = value;
			}
		}

		#region IList<T> Members

		int IList<T>.IndexOf(T item) {
			return wrappedIListT.IndexOf(item);
		}

		void IList<T>.Insert(int index, T item) {
			wrappedIListT.Insert(index, item);
		}

		void IList<T>.RemoveAt(int index) {
			wrappedIListT.RemoveAt(index);
		}

		T IList<T>.this[int index] {
			get {
				return wrappedIListT[index];
			}
			set {
				wrappedIListT[index] = value;
			}
		}

		#endregion

		#region ICollection<T> Members

		void ICollection<T>.Add(T item) {
			wrappedIListT.Add(item);
		}

		void ICollection<T>.Clear( ) {
			wrappedIListT.Clear( );
		}

		bool ICollection<T>.Contains(T item) {
			return wrappedIListT.Contains(item);
		}

		void ICollection<T>.CopyTo(T[] array, int arrayIndex) {
			wrappedIListT.CopyTo(array, arrayIndex);
		}

		int ICollection<T>.Count {
			get { return wrappedIListT.Count; }
		}

		bool ICollection<T>.IsReadOnly {
			get { return wrappedIListT.IsReadOnly; }
		}

		bool ICollection<T>.Remove(T item) {
			return wrappedIListT.Remove(item);
		}

		#endregion

		#region IEnumerable<T> Members

		IEnumerator<T> IEnumerable<T>.GetEnumerator( ) {
			return wrappedIListT.GetEnumerator( );
		}

		#endregion
	}
}
